function [data_train_pca,data_test_pca,score_all,eigvalues_all,avg_img_allpers,V_pca,data_train,data_test,data_train_reconstruct,fisher_train,fisher_test,fisher_basis]=eigen_faces(input,no_persons,no_train,no_total,thresh,flag_fisher);
% Compute eigenfaces for the Train and Test data

% Generate training data
[data_train,data_test]=generate_data(input,no_train,no_total,no_persons);
clear input
 
% Substract average vector from Train/Test data
size_data_train=size(data_train);
size_data_test=size(data_test);
avg_img_allpers=mean(data_train')';
for i=1:size_data_train(2)
    data_train_center(:,i)=data_train(:,i)-avg_img_allpers;
end
for i=1:size_data_test(2)
    data_test_center(:,i)=data_test(:,i)-avg_img_allpers;
end
        
%========================================================
% Perform PCA and sort eigenvalues
%========================================================
data_pca=[];
V_pca_allpers=[];
score_all=[];
numvecs=round(thresh*size_data_train(1)); % number of selected eigenvectors
[V_pca,eigvalues_all]=pc_evectors(data_train,numvecs);

% Plot sorted eigenvalues (in order to select the significant ones!) 
size_eigvalues=size(eigvalues_all);
for p=1:50
    score_all(p)=sum(eigvalues_all(1:round(p*0.02*size_eigvalues(1))))/sum(eigvalues_all);
end
plot(score_all)

% Compute feature vectors (project data on a subspace spanned by significant eigenvectors)
data_train_pca=V_pca'*data_train_center;
data_test_pca=V_pca'*data_test_center;

% Perform Fisher analysis
if flag_fisher == 1
    no_test=no_total-no_train;
    [fisher_train,fisher_test,fisher_basis]=fisher(data_train_pca,data_test_pca,no_persons,no_train,no_test);
else
    fisher_train=[];
    fisher_test=[];
    fisher_basis=[];
end

data_train_reconstruct=V_pca*V_pca'*data_train_center;
data_train_reconstruct=data_train_reconstruct+repmat(avg_img_allpers,1,size(data_train_reconstruct,2));

